Skip to main content
`Ctrl`+`K`

# MatMatMult

Performs matrix-matrix multiplication C=A*B.

## Synopsis

    #include "petscmat.h"
    PetscErrorCode MatMatMult(Mat A, Mat B, MatReuse scall, PetscReal fill, Mat *C)

Neighbor-wise Collective

## Input Parameters

- A - the left matrix

- B - the right matrix

- scall - either `MAT_INITIAL_MATRIX` or `MAT_REUSE_MATRIX`

- fill - expected fill as ratio of nnz(C)/(nnz(A) + nnz(B)), use `PETSC_DETERMINE` or `PETSC_CURRENT` if you do not have a good estimate if the result is a dense matrix this is irrelevant

## Output Parameter

- C - the product matrix

## Notes

Unless scall is `MAT_REUSE_MATRIX` C will be created.

`MAT_REUSE_MATRIX` can only be used if the matrices A and B have the same nonzero pattern as in the previous call and C was obtained from a previous call to this function with `MAT_INITIAL_MATRIX`.

To determine the correct fill value, run with `-info` and search for the string “Fill ratio” to see the value actually needed.

In the special case where matrix `B` (and hence `C`) are dense you can create the correctly sized matrix `C` yourself and then call this routine with `MAT_REUSE_MATRIX`, rather than first having `MatMatMult()` create it for you. You can NEVER do this if the matrix `C` is sparse.

The deprecated `PETSC_DEFAULT` in `fill` also means use the current value

## Example of Usage

         MatProductCreate(A,B,NULL,&C);
         MatProductSetType(C,MATPRODUCT_AB);
         MatProductSymbolic(C);
         MatProductNumeric(C); // compute C=A * B
         MatProductReplaceMats(A1,B1,NULL,C); // compute C=A1 * B1
         MatProductNumeric(C);
         MatProductReplaceMats(A2,NULL,NULL,C); // compute C=A2 * B1
         MatProductNumeric(C);

## See Also

Matrices, `Mat`, `MatProductType`, `MATPRODUCT_AB`, `MatTransposeMatMult()`, `MatMatTransposeMult()`, `MatPtAP()`, `MatProductCreate()`, `MatProductSymbolic()`, `MatProductReplaceMats()`, `MatProductNumeric()`

## Level

intermediate

## Location

src/mat/interface/matrix.c

## Examples

src/snes/tutorials/ex70.c
src/ksp/ksp/tutorials/ex27.c
src/tao/pde_constrained/tutorials/parabolic.c
src/tao/pde_constrained/tutorials/elliptic.c
src/ksp/pc/tutorials/ex4.c

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages